Subject: Re: [core] Opsdir last call review of draft-ietf-core-hop-limit-05

From: Carsten Bormann <[email-masked]>
Date: Wed, 2 Oct 2019 17:47:36 +0200

On Sep 27, 2019, at 14:24, Carsten Bormann <[email-masked]> wrote:
> 
> The other question was why the hop-limit option isn’t made mandatory.  Med has already pointed out that the text of the draft does recommend its use in specific situations (i.e., where proxies are involved).  The transition strategy is somewhat mild, as proxies today don’t know the option, so its interpretation by a receiving instance is elective (i.e., not critical).
> Application domains that do make use of complicated proxying structures (which is not the norm today for CoAP), such as DOTS, might make more stringent requirements.  Generally, we don’t use “updates” for specifications that merely exercise an extension point, so I don’t think hop-limit “updates” RFC 7252, but the “updates” label is in active discussion already anyway.

In the CoRE Virtual Interim we just had (minutes to be posted), we said that the WG wouldn’t have a problem with changing the “are expected to” (implement and default-enable) in Section 1.1 into a stronger MUST.  This would still leave the option for a Proxy operator to turn off the use of the Option, i.e., a receiver cannot rely on actually receiving it.  Let’s wait for the ADs to chime in on that…

Grüße, Carsten

---

From: Thomas Fossati <[email-masked]>
Date: Wed, 2 Oct 2019 16:31:17 +0000

Hi Carsten,

[trimming the CC list to CoRE only]

On 02/10/2019, 16:47, "core on behalf of Carsten Bormann" <[email-masked] on behalf of [email-masked]> wrote:
> In the CoRE Virtual Interim we just had (minutes to be posted), we
> said that the WG wouldn’t have a problem with changing the “are
> expected to” (implement and default-enable) in Section 1.1 into a
> stronger MUST.  This would still leave the option for a Proxy operator
> to turn off the use of the Option, i.e., a receiver cannot rely on
> actually receiving it.  Let’s wait for the ADs to chime in on that…

Having thought a bit more on the specific change that was discussed
during the interim:

   CoAP proxies that do not have specific knowledge that proxy
   forwarding loops are avoided in some other way, MUST
   implement this option and have it enabled by default.

I think this should be tweaked further.

How I read the sentence is: "You can't deploy a proxy box that can
potentially be part of a forwarding loop, if that box is not able to
understand and process the option."

Trouble is that the conditional clause looks implausible in general - it
seems to presume divination skills.

If we want this option to be part of the future CoAP ecosystem (which I
think is a good thing), we should just say something like:

   Newly deployed CoAP proxies MUST implement this option and have it
   enabled by default.

One of the good properties about this option IIUC is that even one
implementer can make a difference -- i.e., you don't need fork-lift
upgrades to start getting some benefit.

Cheers, t

IMPORTANT NOTICE: The contents of this email and any attachments are confidential and may also be privileged. If you are not the intended recipient, please notify the sender immediately and do not disclose the contents to any other person, use it for any purpose, or store or copy the information in any medium. Thank you.

---

From: <[email-masked]>
Date: Thu, 3 Oct 2019 06:10:14 +0000

Hi Thomas, all,

Now that the WG went for a "MUST", I think that your proposed wording is much better. 

Cheers,
Med

> -----Message d'origine-----
> De : core [mailto:[email-masked]] De la part de Thomas Fossati
> Envoyé : mercredi 2 octobre 2019 18:31
> À : Carsten Bormann
> Cc : [email-masked]
> Objet : Re: [core] Opsdir last call review of draft-ietf-core-hop-limit-05
> 
> Hi Carsten,
> 
> On 02/10/2019, 16:47, "core on behalf of Carsten Bormann" <core-
> [email-masked] on behalf of [email-masked]> wrote:
> IMPORTANT NOTICE: The contents of this email and any attachments are
> confidential and may also be privileged. If you are not the intended
> recipient, please notify the sender immediately and do not disclose the
> contents to any other person, use it for any purpose, or store or copy the
> information in any medium. Thank you.
> _______________________________________________
> core mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/core

---

From: <[email-masked]>
Date: Tue, 15 Oct 2019 14:18:40 +0000

Hi all, 

The change proposed by Thomas is sensible. 

Since no objection was raised, we will implement the following change in -07:

OLD:

NEW:
    New CoAP proxies MUST implement this option and have it
    enabled by default.

Cheers,
Med

> De : core [mailto:[email-masked]] De la part de
> [email-masked]
> Envoyé : jeudi 3 octobre 2019 08:10
> À : Thomas Fossati; Carsten Bormann
> Cc : [email-masked]